package org.wfc.omada.api.organization.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.Pattern;
import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

/**
 * SiteTemplateBriefOpenApiVo
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:17:18.430+08:00[Asia/Shanghai]")

public class SiteTemplateBriefOpenApiVo   {
  @JsonProperty("id")
  private String id;

  @JsonProperty("omadacId")
  private String omadacId;

  @JsonProperty("name")
  private String name;

  @JsonProperty("category")
  private String category;

  @JsonProperty("settings")
  @Valid
  private List<String> settings = null;

  public SiteTemplateBriefOpenApiVo id(String id) {
    this.id = id;
    return this;
  }

  /**
   * Site Template ID
   * @return id
  */
  @ApiModelProperty(value = "Site Template ID")


  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public SiteTemplateBriefOpenApiVo omadacId(String omadacId) {
    this.omadacId = omadacId;
    return this;
  }

  /**
   * Omada ID
   * @return omadacId
  */
  @ApiModelProperty(value = "Omada ID")


  public String getOmadacId() {
    return omadacId;
  }

  public void setOmadacId(String omadacId) {
    this.omadacId = omadacId;
  }

  public SiteTemplateBriefOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Name of the site template should contain 1 to 64 characters.
   * @return name
  */
  @ApiModelProperty(value = "Name of the site template should contain 1 to 64 characters.")

@Pattern(regexp="^[^ \\+\\-\\@\\=]$|^[^ \\+\\-\\@\\=].{0,62}[^ ]$") 
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public SiteTemplateBriefOpenApiVo category(String category) {
    this.category = category;
    return this;
  }

  /**
   * category of the site template
   * @return category
  */
  @ApiModelProperty(value = "category of the site template")


  public String getCategory() {
    return category;
  }

  public void setCategory(String category) {
    this.category = category;
  }

  public SiteTemplateBriefOpenApiVo settings(List<String> settings) {
    this.settings = settings;
    return this;
  }

  public SiteTemplateBriefOpenApiVo addSettingsItem(String settingsItem) {
    if (this.settings == null) {
      this.settings = new ArrayList<>();
    }
    this.settings.add(settingsItem);
    return this;
  }

  /**
   * settings of the site template
   * @return settings
  */
  @ApiModelProperty(value = "settings of the site template")


  public List<String> getSettings() {
    return settings;
  }

  public void setSettings(List<String> settings) {
    this.settings = settings;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SiteTemplateBriefOpenApiVo siteTemplateBriefOpenApiVo = (SiteTemplateBriefOpenApiVo) o;
    return Objects.equals(this.id, siteTemplateBriefOpenApiVo.id) &&
        Objects.equals(this.omadacId, siteTemplateBriefOpenApiVo.omadacId) &&
        Objects.equals(this.name, siteTemplateBriefOpenApiVo.name) &&
        Objects.equals(this.category, siteTemplateBriefOpenApiVo.category) &&
        Objects.equals(this.settings, siteTemplateBriefOpenApiVo.settings);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, omadacId, name, category, settings);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SiteTemplateBriefOpenApiVo {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    omadacId: ").append(toIndentedString(omadacId)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    category: ").append(toIndentedString(category)).append("\n");
    sb.append("    settings: ").append(toIndentedString(settings)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

